/***************************************************************************
 *   Copyright (C) 2000-2008 by Johan Maes                                 *
 *   on4qz@telenet.be                                                      *
 *   http://users.telenet.be/on4qz                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CONFIGDIALOG_H
#define CONFIGDIALOG_H

#include "ui_configform.h"

/** @author Johan Maes - ON4QZ */






class configForm;

//! configuration Dialog

class configDialog: public QDialog, private Ui::configForm
{
Q_OBJECT
public:
    configDialog(QWidget *parent = 0, const char *name = 0);
    ~configDialog();
		void writeSettings();
		void readSettings();
		void exec();

		
public slots:
		void slotBrowseRxImagesPath();
		void slotBrowseTxImagesPath();
		void slotBrowseTemplatesPath();
		void slotBrowseAudioPath();
		void slotBrowseDocPath();
    void slotRp1BrowseButton();
    void slotRp2BrowseButton();
    void slotRp3BrowseButton();
    void slotRp4BrowseButton();
    void slotRepeaterTemplateBrowseButton();
    void slotIdleTemplateBrowseButton();
    void slotEnableCAT();
    void slotEnablePTT();

private:
		void getParams();
		void setParams();

};



#endif
