#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

namespace Ui {
    class MainWindow;
}

class mainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit mainWindow(QWidget *parent = 0);
    ~mainWindow();
  void init();
public slots:
  void slotConfigure();
  void slotExit();
  void slotCalibrate();
  void slotAboutQt();
  void slotAboutQSSTV();
  void slotUserGuide();
  void slotResetLog();
  void slotLogSettings();
  #ifndef QT_NO_DEBUG
  void slotShowScope();
  #endif

private:
    Ui::MainWindow *ui;
    void closeEvent ( QCloseEvent *e );
    void getParams();
    void setParams();
    void writeSettings();
    void readSettings();
};

#endif // MAINWINDOW_H
